//======================================================================
// variAnt_avoid_obstacles.ino 
//
// This example uses some basic functions of the VariAnt library.
// It shows how to make the Robot-Ant run around and avoid obstacles. 
// Parameters and threshold values may have to be adjusted individually.
// For more information, go to: https://www.variobot.com/variant
//
// created  May     2022 by Tino Werner
// modified October 2022 by Tino Werner
// Copyright (c)    2022 VARIOBOT
//======================================================================

#include <VariAnt.h>

//#define TEST

VariAnt ant;

void setup()
{ 
  #ifdef TEST
    Serial.begin(57600);
  #endif

  ant.setup();
}

void loop()
{ 
  ant.update( ); //the update function must be called regularly 

  //running speed is reduced by a shadow on the left jaw claw
  ant.setSpeed(255 - ant.getSensor(L2)/8);

  //if shadow on the feeler or front leg, then turn away one step
  if(ant.senseShadow(850, L0, L1)) 
    ant.stepBack(0,1); 
  if(ant.senseShadow(850, R0, R1)) 
    ant.stepBack(1,0);  

  //if shadow on a feeler or both claws, run backward 1 step and turn 3 steps (90°)
  if(ant.senseShadow(900, L0, L2, R2))
    ant.stepBack(1,4);
  if(ant.senseShadow(900, L2, R2, R0))
    ant.stepBack(4,1);

  #ifdef TEST
    ant.printSensors(500); // Print the 9 sensor values (parameter=interval)
  #endif
}
