//======================================================================
// variAnt_follow_line.ino 
//
// This example uses some basic functions of the VariAnt library.
// It shows how to make the Robot-Ant follow a dark line.
// The constant values DIFF_REDUCTION may have to be adjusted individually.
//
// For more information, go to: https://www.variobot.com/variant
//
// created  April   2023 by Tino Werner
// Copyright (c)    2023 VARIOBOT
//======================================================================

#include <VariAnt.h>

const int DIFF_REDUCTION = 6;   // reduction factor of the speed difference

byte speed = 160;               // current speed
int diff;                       // difference of sensor values of the feelers

VariAnt ant; 

void setup()
{ 
  #ifdef TEST
    Serial.begin(57600);
  #endif

  ant.setup(4,1); // set a higher acceleration value for faster reaction (default is 1) and turn of syncronisation
}

void loop()
{ 
  ant.update(); 

  if(ant.buttonPressed(LEFT))
    speed = max(speed-32,0); //lower speed
  if(ant.buttonPressed(RIGHT))
    speed = min(speed+32,255); //higher speed

  diff = (ant.getSensor(L0) - ant.getSensor(R0)) / DIFF_REDUCTION;

  ant.setSpeed(constrain(speed-diff, 0, 255), constrain(speed+diff, 0, 255));

  ant.showSensors(); // 2 PWM LEDs show the sensor values of L0 and R0

}
