//======================================================================
// variAnt_test.ino 
//
// This code is for testing the synchronized movement of the motors.
// You can change the running speed by short pressing the push buttons.
// Make variAnt rotate left or right by long pressing the push buttons.
// For more information, go to: https://www.variobot.com/variant
//
// created  May     2022 by Tino Werner
// modified October 2022 by Tino Werner
// Copyright (c)    2022 VARIOBOT
//======================================================================

#include <VariAnt.h>

VariAnt ant;

#define TEST

void setup()
{ 
  #ifdef TEST
    Serial.begin(57600);
  #endif

  ant.setup();
  ant.setSpeed(160);
}

void loop()
{ 
  ant.update( ); 

  if(ant.buttonPressed(LEFT, SHORT))
    ant.changeSpeed(-32);
  if(ant.buttonPressed(RIGHT, SHORT))
    ant.changeSpeed(32);

  if(ant.buttonPressed(LEFT, LONG))
    ant.stepBack(15, 3);
  if(ant.buttonPressed(RIGHT, LONG))
    ant.stepBack(3, 15);
    
  #ifdef TEST
    ant.printSensors(500); // Print the 9 sensor values (parameter=interval)
  #else
    ant.showShadows(500); // LEDs show shadows of 8 sensors (parameter=threshold)
  #endif
}
